Package org.osgi.framework.hooks.service

# Interface EventListenerHook

@ConsumerType public interface EventListenerHook
OSGi Framework Service Event Listener Hook Service.

Bundles registering this service will be called during framework service (register, modify, and unregister service) operations.

Since:
  1.1
Author:
  $Id: 2b80241ca24005be3a9a3550138e1ba9a3a9ad6e $

## Method Summary

Modifier and Type
Method
Description
`void`
`event(ServiceEvent event, Map<BundleContext,Collection<ListenerHook.ListenerInfo>> listeners)`
Event listener hook method.

## Method Details

### event

void event(ServiceEvent event, Map<BundleContext,Collection<ListenerHook.ListenerInfo>> listeners)
Event listener hook method. This method is called prior to service event delivery when a publishing bundle registers, modifies or unregisters a service. This method can filter the listeners which receive the event.

Parameters:
  `event` - The service event to be delivered.
  `listeners` - A map of Bundle Contexts to a collection of Listener Infos for the bundle's listeners to which the specified event will be delivered. The implementation of this method may remove bundle contexts from the map and listener infos from the collection values to prevent the event from being delivered to the associated listeners. The map supports all the optional `Map` operations except `put` and `putAll`. Attempting to add to the map will result in an `UnsupportedOperationException`. The collection values in the map supports all the optional `Collection` operations except `add` and `addAll`. Attempting to add to a collection will result in an `UnsupportedOperationException` . The map and the collections are not synchronized.